/* -*- C++ -*- */
//=============================================================================
/**
 *  @file    PG_Utils.h
 *
 *  PG_Utils.h,v 1.4 2004/02/04 20:20:23 parsons Exp
 *
 *  Utility methods
 *
 *  @author Balachandran Natarajan <bala@dre.vanderbilt.edu>
 */
//=============================================================================
#ifndef TAO_PORTABLEGROUP_UTILS_H
#define TAO_PORTABLEGROUP_UTILS_H
#include /**/ "ace/pre.h"

#include "orbsvcs/orbsvcs/PortableGroupC.h"

#if !defined (ACE_LACKS_PRAGMA_ONCE)
# pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */

#include "portablegroup_export.h"

namespace TAO
{
  /**
   * @class PG_Utils
   *
   * @brief Simple utility class
   */
  class TAO_PortableGroup_Export PG_Utils
  {
    public:

    /// Set tagged component for the object group
    static CORBA::Boolean set_tagged_component (
        PortableGroup::ObjectGroup *&ior,
        PortableGroup::TagGroupTaggedComponent &t);

    /// Get tagged component for the object group
    static CORBA::Boolean get_tagged_component (
        PortableGroup::ObjectGroup *&ior,
        PortableGroup::TagGroupTaggedComponent &t);

  private:
    static CORBA::Boolean encode_properties (
        TAO_OutputCDR &cdr,
        PortableGroup::TagGroupTaggedComponent &tg);
  };
}



#include /**/ "ace/post.h"
#endif /*TAO_PORTABLEGROUP_UTILS_H*/
